'use strict';

var isU8a = require('@polkadot/util/is/u8a'); // Copyright 2017-2018 Jaco Greeff
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.


var u8aConcat = require('@polkadot/util/u8a/concat');
var u8aFromString = require('@polkadot/util/u8a/fromString');
var xxhash = require('@polkadot/util-crypto/xxhash/asU8a128');

var EMPTY_KEY = new Uint8Array([]);

module.exports = function key(_prefix) {
  var isHashed = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

  var prefix = isU8a(_prefix)
  // flowlint-next-line unclear-type:off
  ? _prefix :
  // flowlint-next-line unclear-type:off
  u8aFromString(_prefix);

  return function (key) {
    var prefixedKey = u8aConcat(prefix, key || EMPTY_KEY);

    return isHashed ? xxhash(prefixedKey) : prefixedKey;
  };
};