'use strict';

// Copyright 2017-2018 Jaco Greeff
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
var _getBn = require('./getBn');
var _setBn = require('./setBn');

module.exports = function wrap(db) {
  var clear = db.clear,
      commit = db.commit,
      del = db.del,
      isEmpty = db.isEmpty,
      get = db.get,
      pairs = db.pairs,
      set = db.set;


  return {
    clear: clear,
    commit: commit,
    del: del,
    isEmpty: isEmpty,
    get: get,
    pairs: pairs,
    set: set,
    getBn: function getBn(key, bitLength) {
      return _getBn(db, key, bitLength);
    },
    setBn: function setBn(key, value, bitLength) {
      return _setBn(db, key, value, bitLength);
    }
  };
};